﻿Imports Utils.WP7.Bing.BingGeo
Imports Microsoft.Phone.Controls.Maps
Imports System.ComponentModel

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Implements INotifyPropertyChanged

#Region "Events"
    Public Event PropertyChanged As PropertyChangedEventHandler Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
#End Region

#Region "Fields and Properties"

    Private _location As GeocodeLocation
    Public Property Location As GeocodeLocation
        Get
            Return _location
        End Get
        Set(ByVal value As GeocodeLocation)
            _location = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Location"))
        End Set
    End Property

    Private _error As String
    Public Property [Error] As String
        Get
            Return _error
        End Get
        Set(ByVal value As String)
            _error = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Error"))
        End Set
    End Property
#End Region

    Public Sub New()
        InitializeComponent()
        DataContext = Me
    End Sub

    Private Sub OnCloud(ByVal sender As Object, ByVal e As RoutedEventArgs)
        TryCast(App.Current, App).RootFrame.Navigate(New Uri("/Examples/RestaurantsView.xaml", UriKind.Relative))
    End Sub

    Private Sub OnGeoRequest(ByVal sender As Object, ByVal evt As System.Windows.RoutedEventArgs)
        ' Reset display.
        [Error] = String.Empty
        Location = Nothing

        ' Create the request.
        Dim geoRequest = New GeocodeRequest
        geoRequest.Credentials = New Credentials
        geoRequest.Credentials.ApplicationId = App.BingApiKey
        geoRequest.Address = New Address
        geoRequest.Address.CountryRegion = "Belgium"
        geoRequest.Address.PostalTown = "Brussels"

        ' Execute the request and display the results.
        Dim geoClient = New GeocodeServiceClient("BasicHttpBinding_IGeocodeService")
        geoClient.GeocodeAsync(geoRequest)
        AddHandler geoClient.GeocodeCompleted,
            Sub(s, e)
                If e.Result IsNot Nothing AndAlso e.Result.Results.Any(
                    Function(o) o.Locations IsNot Nothing AndAlso o.Locations.Any()) Then
                    Location = e.Result.Results.FirstOrDefault().Locations.FirstOrDefault()
                ElseIf e.Error IsNot Nothing Then
                    [Error] = e.Error.Message
                Else
                    [Error] = "No results or locations found."
                End If
            End Sub
    End Sub

    Private Sub OnCalculateRoute(ByVal sender As Object, ByVal e As RoutedEventArgs)
        TryCast(App.Current, App).RootFrame.Navigate(New Uri("/Examples/RouteView.xaml", UriKind.Relative))
    End Sub

End Class