﻿Imports System.Device.Location
Imports System.Collections.Generic

Imports Microsoft.Phone.Controls.Maps
Imports Microsoft.Phone.Controls.Maps.Platform

Public Module LocationExtensions
    <System.Runtime.CompilerServices.Extension()>
    Public Function ToCoordinate(ByVal routeLocation As Location) As GeoCoordinate
        Return New GeoCoordinate(routeLocation.Latitude, routeLocation.Longitude)
    End Function
    <System.Runtime.CompilerServices.Extension()>
    Public Function ToLocation(ByVal coordinate As GeoCoordinate) As Location
        Return New Location With
               {.Latitude = coordinate.Latitude,
                .Longitude = coordinate.Longitude}
    End Function

    <System.Runtime.CompilerServices.Extension()>
    Public Function ToCoordinates(ByVal points As IEnumerable(Of Location)) As LocationCollection
        Dim locations = New LocationCollection

        If points IsNot Nothing Then
            For Each point In points
                locations.Add(point.ToCoordinate())
            Next point
        End If

        Return locations
    End Function
End Module
